<template>
  <div>
    <rui-empty v-if="notifications.length === 0" class="-md" :content="$t('js.notifications.no_notification')" />
    <template v-else>
      <section>
        <template v-for="notification in notifications" :key="notification.id">
          <component :is="notificationComponent(notification)" :notification="notification" />
        </template>
      </section>

      <rui-actions v-if="notifications.length > 0" bottom>
        <rui-button icon="archive" @click="archiveAll">
          {{ $t('js.notifications.archive_all') }}
        </rui-button>
        <rui-button variant="destructive" icon="trash" @click="destroyAllArchived">
          {{ $t('js.notifications.delete_all_archived') }}
        </rui-button>
      </rui-actions>
    </template>
  </div>
</template>

<script>
import RuiActions from '@experiments-labs/rise_ui/src/components/Actions/Actions.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'

import GpaCommentNotification from './_Comment.vue'
import GpaSystemNotification from './_System.vue'
import GpaTeamMateNotification from './_TeamMate.vue'

export default {
  name: 'GpaNotifications',
  components: { RuiButton, RuiActions, RuiEmpty },
  data () {
    return {
      loading: false,
    }
  },
  computed: {
    notifications () { return this.$store.getters.notifications },
  },
  methods: {
    notificationComponent (notification) {
      switch (notification.type) {
        case 'NewCommentNotification': return GpaCommentNotification
        case 'SystemNotification': return GpaSystemNotification
        case 'TeamMateAcceptNotification':
        case 'TeamMateInviteNotification':
        case 'TeamMateLeaveNotification':
        case 'TeamMateRefuseNotification':
        case 'TeamMateRemoveNotification': return GpaTeamMateNotification
        default: throw new Error(`Unhandled notification type "${notification.type}"`)
      }
    },
    archiveAll () {
      this.loading = true
      this.$store.dispatch('archiveAllNotifications')
        .then().catch().then(() => { this.loading = false })
    },
    destroyAllArchived () {
      this.loading = true
      this.$store.dispatch('destroyAllNotifications')
        .then().catch().then(() => { this.loading = false })
    },
  },
  created () {
    this.loading = true
    this.$store.dispatch('loadNotifications')
      .then().catch().then(() => { this.loading = false })
  },
}
</script>
